/*
 * Programmieren fuer Physiker, SS 2023, Blatt 08, Aufgabe 22
 *
 * Tuerme von Hanoi -- kurze Loesung 
 * (nur Umlegoperationen ausgegeben, Stangenzustand nicht explizit)
 */

#include <iostream>
using namespace std ;

void Hanoi( int n, char quelle, char ziel, char hilf) 
{
    // Lege n Scheiben von Stange 'quelle' nach Stange 'ziel'
    // unter Verwendung der Hilfsstange 'hilf'
    // Jede Stange hat einen 'char'-Namen.

    if( n==0) return ; // nichts zu tun.

    // Vorgehen: n-1 Scheiben von 'quelle' nach 'hilf' bringen
    //           Scheibe n von 'quelle' nach 'ziel' legen
    //           die n-1 von 'hilf' nach 'ziel'
    Hanoi( n-1, quelle, hilf, ziel) ;
    // das eigentliche Umlegen der Scheiben:
    //   nichts zu tun ausser Bildschirm-Ausgabe
    cout << "Lege Scheibe " << n << " von " << quelle
	 << " nach " << ziel << endl ; 
    Hanoi( n-1, hilf, ziel, quelle) ;
}

int main()
{
    int n ;
    cout << "Tuerme von Hanoi" << endl ;
    cout << "Wieviel Scheiben: " ;
    cin >> n ;
    Hanoi( n, 'A', 'B', 'C') ;
}
